import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class Spline2 extends Frame
{  public int Iter,Itermax; public double Err;
   public Spline2()
   {  setSize(800,300);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double func(double P1, double P2, double P3, double Sigma1, double Sigma2)
   {  return (3 * ((P2 - P1) * Sigma2 / Sigma1 + (P3 - P2) * Sigma1 / Sigma2));}

   public void clamped(double [][]A, double[]Sigma, double Pd, double Dd, intN) // Œ
   {  int i, j, k;
      double[] Dtemp = new double[N]; double [] Ptemp = new double[N];
      A[0][1] = 2 * (Sigma[0] + Sigma[1]);
      A[0][2] = Sigma[0];
      A[N - 3][0] = Sigma[N - 2];
      A[N - 3][1] = 2 * (Sigma[N - 3] + Sigma[N - 2]);
      for( k = 2; k < N-2; k++)   
      { A[k - 1][ 1] = Sigma[k];
        A[k - 1][ 2] = 2 * [Sigma[k - 1] + Sigma[k]);
        A[k - 1][ 3] = Sigma[k - 1];
      }
      for(j = 0;j<2;j++)
      {
        for(k=1;k<N-1;k++)
          Dd[j][ k - 1] = func(Point[k - 1][ j], Point[k][ j], Point[k + 1][ j], Sigma[k - 1], Sigma[k]);
        Dd[j][0]     = Dd[j][0]      - Sigma[1]     * P1d[j];
        Dd[j][N - 3] = Dd[j][ N - 3] - Sigma[N - 3] * Pnd[j]
        for(k = 0;k < N; k++) Dtemp[k] = Dd[j][ k];
        TriDiag( A, Dtemp, Ptemp, N - 2);
        for(k = 0; k < N - 1; k++) Pd[j][ k + 1] = Ptemp[k];
        Pd[j][ 0    ] = P1d[j]; Pd[j][ N - 1] = Pnd[j];
     }
  }
  

 public double[][] Interpolation(double []X, double []Y, int N)
   { int ID = (N-1)*10+1;
     double [][] XY = new double[2][ID];  
     double []   DY = new double[N];
     for(int i = 0;i < N; i++)
     { if     (i == 0    )  DY[i] = (Y[1] - Y[0]) / (X[1] - X[0]);
       else if(i == (N-1))  DY[i] = (Y[N - 1] - Y[N - 2]) / (X[N - 1] - X[N - 2]);
       else                 DY[i] = (Y[i + 1] - Y[i - 1]) / (X[i + 1] - X[i - 1]);
     } 
     for(int k = 0; k < N - 1; k++)
     {
        double DX = (X[1] - X[0]);
        double DX2 = DX * DX; double DX3 = DX * DX2;
        double A1 = 2 * (Y[k]     - Y[k + 1]) / DX3 + (DY[k]     + DY[k + 1]) / DX2;
        double A2 = 3 * (Y[k + 1] - Y[k]    ) / DX2 - (2 * DY[k] + DY[k + 1]) / DX;
        double A3 = DY[k];  double A4 = Y[k];
        double XN = 0    ;  DX = DX / 10;
        for(int j = 0; j< 10; j++)
        {  ID = k * 10 + j ;
           XY[0][ID] = X[k] + XN;
           double XN2 = XN * XN; double XN3 = XN2 * XN;
           XY[1][ID] = A1 * XN3 + A2 * XN2 + A3 * XN + A4;
           XN += DX;
         }
      }
      ID = (N - 1) * 10 + 1;
      XY[0][ID-1] = X[N-1]; XY[1][ID-1] = Y[N - 1];
      return XY;
   }
   public int Xpos(double X)
   {  return (int)(X*100)+100;}
   public int Ypos(double Y)
   {  return 400- (int)(Y*50);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void paint(Graphics g)
   { double []  X = { 1,2,3,4,5};
     double []  Y = { 3,5,4,6,4};
     double [][]  XY= Interpolation(X, Y, 5);
     setTitle("XvCԁiȕ֖@j");
     g.setColor(new Color(0,0,255));
     for(int i=0;i<=4;i++) drawLine(g,(double)i,0,(double)i,7);
     for(int i=0;i<=7;i++) drawLine(g,0,(double)i,4,(double)i);
     for(int i=1;i<=5;i++) g.drawString(""+i, i*100-4,Ypos(-0.4));
     for(int i=0;i<=7;i++) g.drawString(""+i, Xpos(-0.1),Ypos(i-0.1));
     
     g.setColor(new Color(255,0,0));
    
     for(int i=1;i<41;i++) drawLine(g,XY[0][i-1]-1,XY[1][i-1],XY[0][i]-1,XY[1][i]);
     for(int i=0;i<5;i++)  drawPoint(g,X[i]-1,Y[i]);
     
   } 
   public static void main(String[] args)
   {  Frame w = new Spline2();
      w.setVisible(true);
   }
}
